
PAGE  59,132

;
;								         
;			        CID01				         
;								         
;      Code type: device drivr				         
;      Passes:    5	       Analysis Options on: QRS		         
;								         
;

data_2e		equ	20h ; (0000:0020=3Ch)
data_3e		equ	22h ; (0000:0022=684h)
data_5e		equ	40h ; (0000:0040=0CD1h)
data_6e		equ	42h ; (0000:0042=424h)
data_25e	equ	0   ;*(2020:0000=8Ah)

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a


		org	0

cid01		proc	far

header		dd	0FFFFFFFFh
attributes	dw	0C000h  ;ᨬ쭮
pointers	dw	offset strategy
		dw	offset commands
char_dev	db	'@CID0@   '
;char_dev	db	'@!AON@   '

data_27		dd	00000000h

tabl1		dw	m2f1a	;0        INIT
		dw	m0b7d	;1  0,ret
		dw	m0b7d	;2  0,ret
		dw	m0ecc	;3        uww input
		dw	m1118	;4        input
		dw	m0b7d	;5  0,ret
data_29		dw	m0b7d	;6  0,ret
		dw	m0b7d	;7  0,ret
		dw	m0f75	;8        output
		dw	m0f75	;9        output/verify
		dw	m0b7d	;a  0,ret
		dw	m0b7d	;b  0,ret
		dw	m0e2f	;c        uww output
		dw	m0b7d	;d  0,ret
		dw	m0b7d	;e  0,ret
		dw	m0b7d	;f  0,ret
		dw	m0b7d	;10 0,ret

		dw	m0b7f	;11 ret
		dw	m0b7f	;12 ret
		dw	m0a34	;13
		dw	m0baa	;14
		dw	m09bd	;15
		dw	m0b7f	;16 ret
		dw	m0915	;17
		dw	m0a2b	;18
		dw	m097d	;19 0,ret
		dw	m092b	;1a
		dw	m092f	;1b
		dw	m0a7d	;1c
		dw	m0993	;1d
		dw	m09ae	;1e
		dw	m09d2	;1f
		dw	m0b7f	;20 ret
		dw	m0b7f	;21 ret
		dw	m0b7f	;22 ret
		dw	m0b7f	;23 ret
		dw	m0a3b	;24
		dw	m0bce	;25
		dw	m09c3	;26
		dw	m0b7f	;27 ret
		dw	m0b7f	;28 ret
		dw	m0b7f	;29 ret
		dw	m0b7f	;2a ret
		dw	m0b7f	;2b ret
		dw	m0b7f	;2c ret
		dw	m0a7e	;2d
		dw	m0b7f	;2e ret
		dw	m0b7f	;2f ret
		dw	m09e1	;30
		dw	m0b14	;31
		dw	m0b45	;32

		db	0
		db	128 dup (0)
		db	0
		db	382 dup (0)
m27d		db	0
;mm27e===================================
data_37		dw	0000h
data_38		dw	0
data_39		dd	00000h
	;d_41 - p pp뢠
data_41		db	4
	;d_42 (Interface Level) Ring On = X1
	;	      On during Dialing = 1X
data_42		db	3
	;d_43 - .p p
data_43		dw	3F8h

data_44		db	0
data_45		db	0
data_46		db	1
data_47		db	0

	;d_48 (Number of dials) 0ah=10, 14h=20
data_48		db	0Ah
data_49		db	0Ah
	;m290 (Detect Dial Tone, sec) 2s
m290		db	2
	;m0291 (Detect Busy timeout, sec) 7=70s
m0291		db	7
	;d_52 (Hang Up timeout, sec) 443h=60s,071ah=100s
data_52		dw	443h
	;d_53 - ﭨ DSR
data_53		db	0
	;0 < d_54 <= 3 -  DSR
data_54		db	3
	;d_55 AON status:  Disable = 0
	;		After Ring = 1
	;	     After Hang Up = 2
	;		On Request = 3
data_55		db	2

data_56		db	0
data_57		db	0
data_58		dw	0
data_59		dw	0
data_60		dw	0
data_61		dd	00000h
data_63		dd	00000h
data_65		dd	00000h
data_67		db	0
data_68		dw	0000h
;mm2ae====================================
data_69		dw	0

mm4b0		db	512 dup (0) ;stek
m4b0		db	0
data_70		dw	0
data_71		dw	0
m4b5		db	64h dup (0) ;400 dup (0)
m519		db	64h dup (0)
m57d		db	64h dup (0)
m5e1		db	64h dup (0)

data_72		dw	m4B5
		dw	m519
		dw	m57d
		dw	m5e1

data_73		db	0
data_74		dw	0
data_75		dw	0

data_76		dw	0,0
m0656		db	0CBh
data_78		db	0

cid01		endp

strategy	proc	far
		mov	word ptr cs:data_27,bx
		mov	word ptr cs:data_27+2,es
		retf
strategy	endp

commands	proc	far
		push	ax
		mov	cs:data_68,ss
		mov	cs:data_69,sp
		cli
		mov	ax,cs
		mov	ss,ax
		mov	sp,offset m4B0
		sti
		push	bx
		push	cx
		push	dx
		push	ds
		push	es
		push	di
		push	si
		push	bp
		push	cs
		pop	ds
		les	di,cs:data_27
		mov	bl,es:[di+2]
		xor	bh,bh
		cmp	bx,10h
		jle	loc_28 ;<=
		mov	ax,8003h
		jmp	short loc_29
loc_28:
		shl	bx,1
		call	word ptr cs:[bx+17h]
		NOP	;...........
loc_29:
		les	di,cs:data_27
		or	ax,100h
		mov	es:[di+3],ax
		pop	bp
		pop	si
		pop	di
		pop	es
		pop	ds
		pop	dx
		pop	cx
		pop	bx
		cli
		mov	ss,cs:data_68
		mov	sp,cs:data_69
		sti
		pop	ax
		retf
commands	endp

data_79		dw	0
data_80		db	0

loc_30:	
		push	ax
		mov	al,20h
		out	20h,al
		pop	ax
		popf
		iret

	;int08
m06ca:		pushf
		cmp	cs:data_80,0
		jne	loc_30
		mov	cs:data_80,1
		cmp	cs:data_57,0
		je	loc_31
		call	cs:data_39
		push	bx
		push	cx
		push	dx
		push	ds
		push	es
		push	di
		push	si
		push	bp
		mov	cs:data_44,0
		call	sub_19
		pop	bp
		pop	si
		pop	di
		pop	es
		pop	ds
		pop	dx
		pop	cx
		pop	bx
		cli
		mov	cs:data_80,0
		iret
loc_31:
		push	ax
		mov	al,cs:data_67
		cmp	cs:data_53,al
		je	loc_33
		cmp	cs:data_54,0
		je	loc_32
		dec	cs:data_54
		jnz	loc_33
loc_32:
		mov	al,cs:data_53
		mov	cs:data_67,al
loc_33:
		pop	ax
		cmp	cs:data_44,0
		jne	loc_36
		cmp	cs:data_79,0
		jne	loc_35
		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		add	dx,1
		mov	al,8
		out	dx,al	; port 3F9h, RS232-1 int enable
		;pp.pp.p  STS,DSR,RI,RLSD
		add	dx,3
		mov	al,0Eh	;/DTR=0 /RTS=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	dx
		pop	ax
loc_34:
			;            07E3
		mov	cs:data_80,0
		popf
		jmp	cs:data_39
loc_35:
		mov	cs:data_45,1
		mov	cs:data_44,10h
		mov	cs:data_79,0
		mov	byte ptr cs:data_86,7
		nop
		jmp	short loc_34
loc_36:
		cmp	cs:data_46,1
		jne	loc_38
loc_37:
		call	sub_18
		call	sub_17
		jmp	short loc_34
loc_38:
		cmp	cs:data_67,0
		je	loc_40
		cmp	cs:data_55,2
		jne	loc_37
		cmp	cs:data_44,0Bh
		je	loc_39
		cmp	cs:data_44,0Fh
		jne	loc_37
loc_39:
		mov	cs:data_57,1
		jmp	short loc_34
loc_40:
		push	bx
		xor	bx,bx
		cmp	cs:data_45,1
		je	loc_41
		mov	cs:data_45,1
		call	sub_2
		mov	cs:data_44,bl
		xor	bh,bh
		shl	bx,1
		call	word ptr cs:[bx+39h] ;\\\
		NOP	;..........
		pop	bx
		jmp	loc_34
loc_41:
		mov	bl,cs:data_44
		shl	bx,1
		call	word ptr cs:[bx+5Bh] ;*5 entries
		NOP	;.........
		pop	bx
		jmp	loc_34
;==========================================
	;int0c,0d (irq3,4)
m07e6:		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		add	dx,6
		in	al,dx	; port 3FEh, RS232-1 modem stat
		test	al,1	;  DSR
		jz	loc_42
		cmp	cs:data_67,0
		jne	loc_42
		inc	cs:data_79
loc_42:
		push	bx
		test	al,20h	;DSR
		jz	loc_43
		mov	bl,1	;DSR=1
		jmp	short loc_44
		db	90h
loc_43:
		mov	bl,0 	;DSR=0
loc_44:
		cmp	cs:data_53,bl ;.DSR
		je	loc_45
		mov	cs:data_54,3
		mov	cs:data_53,bl
loc_45:
		pop	bx
		cmp	cs:data_44,0Bh
		je	loc_47
		cmp	cs:data_47,0
		je	loc_47
		push	ax
		mov	al,0B6h
		out	43h,al	; port 43h, 8253 wrt timr mode
				; ,3 p,-,2 
		xor	ax,ax	; -00
		out	42h,al	; port 42h, 8253 timer 2 spkr
		mov	al,0C8h	; -C8
		out	42h,al	; port 42h, 8253 timer 2 spkr
		pop	ax
		and	al,10h
		in	al,61h	; port 61h, 8255 port B, read
		jz	loc_46
		and	al,0FCh	; xxxxxx00
		or	al,2	; xxxxxx10 -  pp襭
		out	61h,al	; port 61h, 8255 B - spkr, etc
		jmp	short loc_47
		db	90h
loc_46:
		and	al,0FCh	; xxxxxx00 -  p饭
		out	61h,al	; port 61h, 8255 B - spkr, etc
loc_47:
		in	al,dx	; port 3FEh, RS232-1 modem stat
		in	al,dx
		mov	ah,cs:data_114
		in	al,21h	; port 21h, 8259-1 int IMR
		jmp	short $+3
		nop
		and	al,ah
		out	21h,al	; port 21h, 8259-1 int comands
		jmp	short $+3
		nop
		mov	al,20h
		out	20h,al	; port 20h, 8259-1 int command
				;  al = 20h, end of interrupt
		pop	dx
		pop	ax
		iret
;=============================================
loc_48:
		mov	bl,cs:data_73
		cmp	bl,1
		je	loc_49
		cmp	bl,2
		je	loc_50
		cmp	bl,3
		je	loc_51
		mov	bl,0Ah
		retn
loc_49:
		mov	bl,8
		inc	cs:data_73
		retn
loc_50:
		mov	bx,14h
		mov	cs:data_84,bx
		xor	bx,bx
		mov	bl,4
		inc	cs:data_73
		retn
loc_51:
		mov	bx,offset data_29
		mov	cs:data_84,bx
		mov	cs:data_79,0
		xor	bx,bx
		mov	bl,4
		inc	cs:data_73
		retn

;	       SUBROUTINE
;
;         Called from:	 7EA9:07C1

sub_2		proc	near
		cmp	cs:data_73,0
		jne	loc_48
		push	si
		push	ax
		mov	si,cs:data_70
		mov	bx,cs:data_71
		mov	al,cs:[bx+si]
		inc	si
		push	ax
		cmp	al,4
		je	loc_53
		cmp	al,2
		je	loc_54
		cmp	al,7
		je	loc_55
		cmp	al,3
		je	loc_56
loc_52:
		pop	ax
		mov	bl,al
		mov	cs:data_70,si
		pop	ax
		pop	si
		retn
loc_53:
		mov	ax,cs:[bx+si]
		inc	si
		inc	si
		mov	cs:data_84,ax
		jmp	short loc_52
loc_54:
		mov	al,cs:[bx+si]
		mov	cs:data_86,al
		inc	si
		jmp	short loc_52
loc_55:
		mov	al,cs:[bx+si]
		mov	cs:data_78,al
		inc	si
		jmp	short loc_52
loc_56:
		push	ax
		mov	al,cs:[bx+si]
		mov	cs:data_99,al
		inc	si
		pop	ax
		jmp	short loc_52
sub_2		endp

m0915:		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		add	dx,4
		mov	al,0Fh	;/DTR=1 /RTS=1 OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		mov	cs:data_45,0
		pop	dx
		pop	ax
		retn

m092b:		call	sub_17
		retn

m092f:		cmp	cs:data_79,0
		call	sub_17
		jz	loc_57
		mov	cs:data_46,1
loc_57:
		dec	cs:data_49
		jz	loc_ret_60
		push	ax
		mov	ax,cs:data_74
		dec	ax
		cmp	cs:data_75,ax
		je	loc_58
		inc	cs:data_75
		jmp	short loc_59
		db	90h
loc_58:
		mov	cs:data_75,0
loc_59:
		push	bx
		mov	bx,cs:data_75
		shl	bx,1
		mov	ax,cs:data_72[bx]
		mov	cs:data_71,ax
		pop	bx
		pop	ax
		mov	cs:data_44,1
loc_ret_60:
		retn

m097d:		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		add	dx,4
		mov	al,0Eh	;/DTR=0 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	dx
		pop	ax
		mov	cs:data_45,0
		retn

m0993:		mov	cs:data_47,0
		test	cs:data_42,2
		jz	loc_61
		mov	cs:data_47,1
loc_61:
		mov	cs:data_45,0
		retn

m09ae:		mov	cs:data_47,1
		mov	cs:data_45,0
		retn

data_84		dw	0

m09bd:		DEC	WORD PTR cs:[data_84]
		RETn

;	       SUBROUTINE
;
;         Called from:	 7EA9:07DD

sub_3		proc	near
m09c3:		dec	cs:data_84
		jz	loc_62
		retn
loc_62:
		mov	cs:data_45,0
		retn
sub_3		endp

m09d2:		mov	cs:data_84,7
		mov	cs:data_79,0
		retn

m09e1:		dec	cs:data_84
		jz	loc_64
		cmp	cs:data_56,0
		je	loc_ret_63
		cmp	cs:data_84,4
		jle	loc_65
		mov	cs:data_79,0
loc_ret_63:
		retn
loc_64:
		mov	cs:data_79,0
		mov	cs:data_45,0
		retn
loc_65:
		cmp	cs:data_79,14h
		jg	loc_66
		mov	cs:data_79,0
		retn
loc_66:
		mov	cs:data_73,1
		mov	cs:data_45,0
		retn
m0a2b:		mov	cs:data_45,0
		retn

data_85		db	0
data_86		db	0

m0a34:		MOV	BYTE PTR cs:[data_85],01
		RETn

;	       SUBROUTINE
;
;         Called from:	 7EA9:07DD

sub_4		proc	near
m0a3b:		cmp	cs:data_85,1
		je	loc_68
		mov	cs:data_85,1
		push	dx
		push	ax
		mov	dx,cs:data_43
		add	dx,4
		mov	al,0Fh	;/DTR=1 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	ax
		pop	dx
		dec	cs:data_86
		jz	loc_67
		retn
loc_67:
		mov	cs:data_45,0
		retn
loc_68:
		push	dx
		push	ax
		mov	dx,cs:data_43
		add	dx,4
		mov	al,0Eh	;/DTR=0 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	ax
		pop	dx
		mov	cs:data_85,0
		retn
sub_4		endp

m0a7d:		retn

m0a7e:		cmp	cs:data_55,1
		jne	loc_69
		mov	cs:data_57,1
		retn
loc_69:
		cmp	cs:data_85,1
		je	loc_73
		mov	cs:data_85,1
		push	ax
		test	cs:data_42,1
		jz	loc_70
		mov	al,0FFh	;-ff
		out	42h,al	; port 42h, 8253 timer 2 spkr
		jmp	short $+3
		nop
		mov	al,1	;-01
		out	42h,al	; port 42h, 8253 timer 2 spkr
		in	al,61h	; port 61h, 8255 port B, read
		or	al,3
		out	61h,al	; port 61h, 8255 B - spkr, etc
loc_70:
		cmp	cs:data_79,0
		je	loc_71
		mov	cs:data_79,0
		pop	ax
		retn
loc_71:
		mov	cs:data_84,50h
		mov	cs:data_44,0Fh
		test	cs:data_42,1
		jz	loc_72
		in	al,61h	; port 61h, 8255 port B, read
		and	al,0FCh
		out	61h,al	; port 61h, 8255 B - spkr, etc
				;  al = 0, disable parity
loc_72:
		pop	ax
		retn
loc_73:
		mov	cs:data_85,0
		push	ax
		cmp	cs:data_79,0
		je	loc_71
		test	cs:data_42,1
		jz	loc_74
		mov	al,0FFh
		out	42h,al	; port 42h, 8253 timer 2 spkr
		jmp	short $+3
		nop
		mov	al,3
		out	42h,al	; port 42h, 8253 timer 2 spkr
		in	al,61h	; port 61h, 8255 port B, read
		or	al,3
		out	61h,al	; port 61h, 8255 B - spkr, etc
loc_74:
		mov	cs:data_79,0
		pop	ax
		retn

m0b14:		cmp	cs:data_79,0
		jne	loc_76
		dec	cs:data_84
		jz	loc_75
		retn
loc_75:
		mov	cs:data_45,0
		mov	cs:data_44,0
		retn
loc_76:
		mov	cs:data_85,1
		mov	cs:data_79,0
		mov	cs:data_44,0Bh
		retn

m0b45:		cmp	cs:data_79,0
		je	loc_77
		dec	cs:data_86
		jz	loc_78
		mov	cs:data_79,0
		retn
loc_77:
		mov	cs:data_45,0
		mov	cs:data_44,0
		retn
loc_78:
		mov	cs:data_85,1
		mov	cs:data_79,0
		mov	cs:data_44,0Bh
		retn

m0b7d:		XOR	AX,AX

;	       SUBROUTINE
;
;         Called from:	 7EA9:07DD

sub_5		proc	near
m0b7f:		retn
sub_5		endp

		mov	cs:data_44,3
		retn
		mov	cs:data_44,5
		retn

data_87		dw	offset sub_7
data_88		dw	offset sub_8
data_89		dw	offset sub_9
data_90		dw	offset sub_10

data_91		dw	offset sub_11
data_92		dw	offset sub_12
data_93		dw	offset sub_13
data_94		dw	offset sub_14
data_95		dw	offset sub_15
data_96		dw	offset sub_16
data_97		dw	offset sub_10
data_98		db	0
data_99		db	0
data_100	db	7
data_101	db	0
data_102	db	0
data_103	db	1

m0baa:		MOV	BYTE PTR cs:[data_98],00
		MOV	BL,cs:[m290]
		CMP	BYTE PTR cs:[data_99],01
		JZ	m0BC2
		MOV	BL,cs:[m0291]
m0bc2:		MOV	cs:[data_100],BL
		MOV	BYTE PTR cs:[data_103],02
		RETn

;	       SUBROUTINE
;
;         Called from:	 7EA9:07DD

sub_6		proc	near
m0bce:		mov	bl,cs:data_98
		shl	bx,1
		cmp	cs:data_99,1
		je	loc_80
		call	word ptr cs:data_91[bx]	; 7 entries
		retn
loc_80:
		call	word ptr cs:data_87[bx]	; 11 entries
		retn
sub_6		endp

data_104	db	12h
data_105	db	4
data_106	db	14h
data_107	db	0

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B8E, 0BE3

sub_7		proc	near
		inc	cs:data_98
		mov	bl,cs:data_106
		mov	cs:data_102,bl
		mov	cs:data_107,0
		mov	cs:data_79,0
		retn
sub_7		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B90, 0BE3

sub_8		proc	near
		cmp	cs:data_79,1Eh
		jl	loc_81
		cmp	cs:data_79,78h
		jg	loc_81
		inc	cs:data_107
loc_81:
		mov	cs:data_79,0
		dec	cs:data_102
		jnz	loc_ret_82
		inc	cs:data_98
		retn

loc_ret_82:
		retn
sub_8		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B92, 0BE3

sub_9		proc	near
		inc	cs:data_98
		mov	bl,cs:data_105
		cmp	cs:data_107,bl
		jl	loc_84
		mov	bl,cs:data_104
		cmp	cs:data_107,bl
		jl	loc_83
		mov	cs:data_101,0
		retn
loc_83:
		mov	cs:data_101,1
		retn
loc_84:
		mov	cs:data_101,2
		retn
sub_9		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B94, 0BA2, 0BDD, 0BE3

sub_10		proc	near
		cmp	cs:data_101,0
		je	loc_88
		cmp	cs:data_101,2
		jne	loc_86
		mov	cs:data_103,2
		dec	cs:data_100
		jnz	loc_87
loc_85:
		mov	cs:data_73,1
		mov	cs:data_45,0
		retn
loc_86:
		dec	cs:data_103
		jz	loc_85
loc_87:
		mov	cs:data_98,0
		retn
loc_88:
		mov	cs:data_45,0
		retn
sub_10		endp

data_108	db	0B6h
data_109	db	0
data_110	db	3
data_111	db	36h
data_112	db	32h

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B96, 0BDD, 0BE3

sub_11		proc	near
		inc	cs:data_98
		mov	bl,cs:data_108
		mov	cs:data_102,bl
		mov	cs:data_107,0
		mov	cs:data_79,0
		mov	cs:data_110,3
		retn
sub_11		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B98, 0BDD, 0BE3

sub_12		proc	near
		cmp	cs:data_79,1Eh
		jl	loc_89
		cmp	cs:data_79,78h
		jg	loc_89
		inc	cs:data_107
		dec	cs:data_110
		jnz	loc_90
		inc	cs:data_98
		mov	cs:data_110,3
		jmp	short loc_90
		db	90h
loc_89:
		mov	cs:data_110,3
loc_90:
		mov	cs:data_79,0
		dec	cs:data_102
		jz	loc_91
		retn
loc_91:
		mov	cs:data_98,5
		retn
sub_12		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B9A, 0BDD, 0BE3

sub_13		proc	near
		cmp	cs:data_79,1Eh
		jl	loc_92
		cmp	cs:data_79,78h
		jg	loc_92
		inc	cs:data_107
		mov	cs:data_110,3
		jmp	short loc_93
		db	90h
loc_92:
		dec	cs:data_110
		jnz	loc_93
		inc	cs:data_98
		mov	cs:data_110,3
		mov	cs:data_109,0
loc_93:
		mov	cs:data_79,0
		dec	cs:data_102
		jz	loc_94
		retn
loc_94:
		mov	cs:data_98,5
		retn
sub_13		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B9C, 0BDD, 0BE3

sub_14		proc	near
		inc	cs:data_109
		cmp	cs:data_79,1Eh
		jl	loc_95
		cmp	cs:data_79,78h
		jg	loc_95
		inc	cs:data_107
		dec	cs:data_110
		jnz	loc_96
		inc	cs:data_98
		mov	cs:data_110,3
		jmp	short loc_96
		db	90h
loc_95:
		mov	cs:data_110,3
loc_96:
		mov	cs:data_79,0
		dec	cs:data_102
		jz	loc_97
		retn
loc_97:
		mov	cs:data_98,5
		retn
sub_14		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0B9E, 0BDD, 0BE3

sub_15		proc	near
		inc	cs:data_109
		cmp	cs:data_79,1Eh
		jl	loc_98
		cmp	cs:data_79,78h
		jg	loc_98
		inc	cs:data_107
		mov	cs:data_110,3
		jmp	short loc_99
		db	90h
loc_98:
		dec	cs:data_110
		jnz	loc_99
		inc	cs:data_98
		mov	cs:data_110,3
loc_99:
		mov	cs:data_79,0
		dec	cs:data_102
		jz	loc_100
		retn
loc_100:
		mov	cs:data_98,5
		retn
sub_15		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:0BA0, 0BDD, 0BE3

sub_16		proc	near
		inc	cs:data_98
		cmp	cs:data_102,0
		je	loc_101
		mov	bl,cs:data_112
		cmp	cs:data_109,bl
		jl	loc_102
		mov	cs:data_101,0
		retn
loc_101:
		mov	bl,cs:data_111
		cmp	cs:data_107,bl
		jl	loc_103
loc_102:
		mov	cs:data_101,1
		retn
loc_103:
		mov	cs:data_101,2
		retn
sub_16		endp

	;UWW output
m0e2f:		mov	cx,es:[di+12h]
	;p㧪 稪 
		les	bx,dword ptr es:[di+0Eh]
	;p㧪 p 
		cmp	cx,5
		je	loc_104
		mov	al,es:[bx]
		cmp	al,1
		je	loc_108
		cmp	al,2
		je	loc_106
		cmp	al,3
		je	loc_107
		cmp	al,4
		je	loc_105
		jmp	short loc_109
		db	90h
loc_104: ;out 5
		mov	ax,es:[bx]
		mov	cs:data_76,ax
		mov	ax,es:[bx+2]
		mov	word ptr cs:[data_76+2],ax ;654h
		jmp	short loc_109
		db	90h
loc_105: ;out 4
		cmp	cs:data_55,3
		jne	loc_109
		mov	cs:data_57,1
		mov	cs:data_44,0
		jmp	short loc_109
		db	90h
loc_106: ;out 2
		mov	al,es:[bx+1]
		mov	cs:data_48,al ;N Dials
		mov	cs:data_49,al
		jmp	short loc_109
		db	90h
loc_107: ;out 3
		mov	al,es:[bx+1]
		mov	cs:data_42,al ;Intrf.level
		jmp	short loc_109
		db	90h
loc_108: ;out 1
		mov	cs:data_46,1
		cmp	cs:data_57,0
		je	loc_109
		mov	byte ptr cs:data_122,8
		nop
		mov	cs:data_44,1
loc_109:
		xor	ax,ax
		retn
loc_110: ; in 2
		mov	al,cs:data_44
		mov	es:[bx],al
		mov	al,cs:data_86
		mov	es:[bx+1],al
		mov	ax,cs:data_84
		mov	es:[bx+2],ax
		jmp	short loc_109

	;UWW input
m0ecc:		mov	cx,es:[di+12h]
	;p㧪 稪 
		les	bx,dword ptr es:[di+0Eh]
	;p㧪 p 
		cmp	cx,4
		je	loc_111
		cmp	cx,2
		je	loc_110
		cmp	cx,1
		je	loc_118
		cmp	cx,7
		je	loc_115
		cmp	cx,5
		je	loc_114
		cmp	cx,20h
		je	loc_112
		jmp	short loc_109
loc_111: ;in 4
		mov	al,cs:data_44
		mov	es:[bx],al
		mov	al,cs:data_48 ;N Dials
		mov	es:[bx+1],al
		mov	al,cs:data_49
		mov	es:[bx+2],al
		mov	al,cs:data_42 ;Interf.level
		mov	es:[bx+3],al
		mov	al,cs:data_55 ;AON status
		mov	es:[bx+4],al
		jmp	short loc_109
loc_112: ;CX=20h
		mov	si,data_25e
		mov	di,offset data_137
locloop_113:
		mov	ax,cs:[di]
		mov	es:[bx+si],ax
		inc	si
		inc	di
		loop	locloop_113
		jmp	short loc_109
loc_114: ;in 5
		mov	ax,cs:data_76
		mov	es:[bx],ax
		mov	ax,word ptr cs:[data_76+2] ;654h
		mov	es:[bx+2],ax
		jmp	loc_109
loc_115: ;in 7 - (LINE NOISE ...)  d_143
			 d_138 14h 
		cld
		push	cs
		pop	ds
		mov	di,bx
		cmp	cs:data_143,0
		je	loc_116
		mov	cx,14h
		mov	si,cs:data_143
		jmp	short loc_117
		db	90h
loc_116:
		mov	si,offset data_138
loc_117:
		rep	movsb
		jmp	loc_109
loc_118: ;in 1
		mov	al,cs:data_122
		mov	es:[bx],al
		mov	al,cs:data_57
		mov	es:[bx+1],al
		jmp	loc_109

data_113	dw	0

	;  output, output/verify
m0f75:		CMP	BYTE PTR cs:[data_44],0Bh
		JZ	m0F8D
		CMP	BYTE PTR cs:[data_44],0Fh
		JZ	m0F8D
		CMP	BYTE PTR cs:[data_44],0
		JNZ	m0FB4
m0f8d:		MOV	WORD PTR cs:[data_74],0
		MOV	WORD PTR cs:[data_75],0
		MOV	AL,cs:[data_48]
		MOV	cs:[data_49],AL
		CALL	sub_18
		CALL	sub_17
		MOV	AX,cs:[data_72]
		MOV	cs:[data_113],AX
		JMP	loc_122

m0fb4:		MOV	SI,cs:[data_74]
		CMP	SI,+04
		JNZ	loc_121
		JMP	loc_131
loc_121:
		shl	si,1
		mov	ax,cs:data_72[si]
		mov	cs:data_113,ax
loc_122:
		mov	cx,es:[di+12h]
		les	bx,dword ptr es:[di+0Eh]
		xor	si,si
		xor	di,di
		mov	dx,bx
		mov	bx,cs:data_113
		mov	byte ptr cs:[bx+di],0Ch
		inc	di
		mov	byte ptr cs:[bx+di],6
		inc	di
		mov	byte ptr cs:[bx+di],4
		inc	di
		mov	byte ptr cs:[bx+di],14h
		inc	di
		mov	byte ptr cs:[bx+di],0
		inc	di
		mov	byte ptr cs:[bx+di],3
		inc	di
		mov	byte ptr cs:[bx+di],1
		inc	di
		cmp	cx,0
		jne	loc_123
		jmp	short loc_130
		db	90h
loc_123:
		mov	bx,dx
		mov	al,es:[bx+si]
		cmp	al,30h
		jl	loc_126
		cmp	al,39h
		jg	loc_126
		mov	bx,cs:data_113
		mov	byte ptr cs:[bx+di],2
		inc	di
		cmp	al,30h
		je	loc_124
		sub	al,30h
		jmp	short loc_125
		db	90h
loc_124:
		mov	al,0Ah
loc_125:
		mov	bx,cs:data_113
		mov	cs:[bx+di],al
		inc	di
		mov	byte ptr cs:[bx+di],0Eh
		inc	di
		jmp	short loc_129
		db	90h
loc_126:
		cmp	al,77h
		je	loc_127
		cmp	al,57h
		je	loc_127
		jmp	short loc_128
		db	90h
loc_127:
		mov	bx,cs:data_113
		mov	byte ptr cs:[bx+di],3
		inc	di
		mov	byte ptr cs:[bx+di],1
		inc	di
		jmp	short loc_129
		db	90h
loc_128:
		cmp	al,2Ch
		jne	loc_129
		mov	bx,cs:data_113
		mov	byte ptr cs:[bx+di],4
		inc	di
		mov	byte ptr cs:[bx+di],25h
		inc	di
		mov	byte ptr cs:[bx+di],0
		inc	di
loc_129:
		inc	si
		cmp	di,56h
		jg	loc_132
		dec	cx
		jcxz	loc_130
		jmp	short loc_123
loc_130:
		mov	bx,cs:data_113
		mov	byte ptr cs:[bx+di],0Dh
		inc	di
		mov	byte ptr cs:[bx+di],3
		inc	di
		mov	byte ptr cs:[bx+di],2
		inc	di
		mov	byte ptr cs:[bx+di],4
		inc	di
		mov	ax,cs:data_52
		mov	cs:[bx+di],ax
		inc	di
		inc	di
		mov	byte ptr cs:[bx+di],8
		inc	di
		mov	byte ptr cs:[bx+di],9
		inc	di
		cmp	di,0Fh
		je	loc_131
		inc	cs:data_74
		cmp	cs:data_44,0
		jne	loc_131
		mov	cs:data_44,1
		mov	ax,cs:data_113
		mov	cs:data_71,ax
loc_131:
		xor	ax,ax
		retn
loc_132:
		les	di,cs:data_27
		mov	word ptr es:[di+12h],0
		mov	ax,5
		retn

;		SUBROUTINE
;
;         Called from:	 7EA9:0783, 092B, 0935, 0FA6, 135F

sub_17		proc	near
		push	ax
		pushf
		mov	cs:data_44,0
		mov	cs:data_70,0
		mov	cs:data_45,0
		mov	cs:data_73,0
		mov	cs:data_79,0
		mov	cs:data_46,0
		mov	cs:data_47,0
		mov	cs:data_57,0
		in	al,61h	; port 61h, 8255 port B, read
		and	al,0FCh
		out	61h,al	; port 61h, 8255 B - spkr, etc
				;  al = 0, disable parity
		popf
		pop	ax
		retn
sub_17		endp

	;input
m1118:		mov	cx,es:[di+12h]
		cmp	cx,4
		jne	loc_133
		les	bx,dword ptr es:[di+0Eh]
		mov	ax,cs:data_75
		mov	es:[bx],ax
		inc	bx
		inc	bx
		mov	ax,cs:data_74
		mov	es:[bx],ax
		xor	ax,ax
		retn
loc_133: ;in 1-3
		les	bx,dword ptr es:[di+0Eh]
		xor	si,si
		push	bx
		mov	bx,cx
		and	bx,3
		shl	bx,1
		mov	di,cs:data_72[bx]
		pop	bx
		mov	cx,64h
locloop_134:
		mov	al,cs:[di]
		mov	es:[bx+si],al
		inc	si
		inc	di
		loop	locloop_134
		xor	ax,ax
		retn

data_114	db	0

;	       SUBROUTINE
;
;         Called from:	 7EA9:0780, 0FA3, 1612, 302E

sub_18		proc	near
m115d:		push	ax
		push	cx
		push	dx
		mov	dx,cs:data_43
		add	dx,1
		mov	al,8
		out	dx,al	; port 3F9h, RS232-1 int enable
		;pp.pp.p . STS,DSR,RI,RLSD
		add	dx,3
		mov	al,0Eh	;/DTR=0 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		add	dx,2
		in	al,dx	; port 3FEh, RS232-1 modem stat
		mov	al,0FEh
		mov	cl,cs:data_41 ;irq3,4
		rol	al,cl
		mov	cs:data_114,al
		mov	ah,al
		in	al,21h	; port 21h, 8259-1 int IMR
		and	al,ah
		out	21h,al	; port 21h, 8259-1 int comands
		in	al,dx	; port 3FEh, RS232-1 modem stat
		mov	al,20h
		out	20h,al	; port 20h, 8259-1 int command
				;  al = 20h, end of interrupt
		pop	dx
		pop	cx
		pop	ax
		retn
sub_18		endp

	;int13
m1193:		pushf
		cmp	cs:data_57,0
		je	loc_135
		call	sub_33
loc_135:
		inc	cs:data_58
		popf
		pushf
		call	cs:data_61 ;int13
		pushf
		dec	cs:data_58
		popf
		retf	2

	;int40
m11b5:		pushf
		cmp	cs:data_57,0
		je	loc_136
		call	sub_34
loc_136:
		inc	cs:data_59
		popf
		pushf
		call	cs:data_65
		pushf
		dec	cs:data_59
		popf
		retf	2

	;int10
m11d7:		pushf
		cmp	cs:data_57,0
		je	loc_137
		call	sub_35
loc_137:
		inc	cs:data_60
		call	cs:data_63
		dec	cs:data_60
		iret

data_115	db	0
data_116	db	0
data_117	db	0
data_118	db	0
data_119	dw	0
data_120	db	0
data_121	db	0
data_122	db	0
data_123	db	0
data_124	dw	0
data_125	dw	0
data_126	db	0
data_127	db	0
data_128	db	0
data_129	db	0
data_130	db	0
data_131	dw	0
data_132	dw	1f1ah, 0000h
data_134	dw	0
data_135	dw	0
		db	10 dup (0FFh)

data_137	dw	16 dup (0)
	;d_138 -   p
data_138	db	0
		db	0, 0, 0, 0, 0
data_139	db	0
		db	25 dup (0)

m125a		db	'<LINE NOISE>       ',0
m126e		db	'<NO ANSWERBACK>    ',0

data_141	dw	0
data_142	dw	121Ah
	;d_143 - p ᮮ饭  뢮
data_143	dw	0
data_144	db	0
data_145	db	4

;		  SUBROUTINE
;
;         Called from:	 7EA9:06F4

sub_19		proc	near
		cli
		push	ax
		mov	cs:data_37,ss
		mov	cs:data_38,sp
		mov	ax,cs
		mov	ss,ax
		mov	sp,offset m27D
		cmp	cs:data_55,0
		jne	loc_138
		jmp	loc_152
loc_138:
		cmp	cs:data_55,3
		jle	loc_139
		jmp	loc_152
loc_139:
		cmp	cs:data_122,8
		jne	loc_140
		jmp	loc_178
loc_140:
		inc	cs:data_123
		cmp	cs:data_122,7
		jne	loc_141
		jmp	loc_156
loc_141:
		cmp	cs:data_58,0
		je	loc_143
		cmp	cs:data_122,0
		jne	loc_142
		mov	cs:data_126,1
loc_142:
		jmp	loc_155
loc_143:
		cmp	cs:data_59,0
		je	loc_144
		cmp	cs:data_122,0
		jne	loc_142
		mov	cs:data_127,1
		jmp	short loc_142
loc_144:
		cmp	cs:data_122,0
		jne	loc_145
		jmp	loc_157
loc_145:
		cmp	cs:data_122,1
		jne	loc_146
loc_146:
		call	sub_20
		sti
		cmp	cs:data_122,2
		jne	loc_147
		jmp	loc_162
loc_147:
		cmp	cs:data_122,3
		jne	loc_148
		jmp	loc_165
loc_148:
		cmp	cs:data_122,4
		jne	loc_149
		jmp	loc_167
loc_149:
		cmp	cs:data_122,5
		jne	loc_150
		jmp	loc_170
loc_150:
		cmp	cs:data_122,6
		je	loc_151
loc_151:
		call	sub_21
		jmp	short loc_152
		db	90h
loc_152:
		push	dx
		push	ax
		mov	al,0Eh
		mov	dx,cs:data_43 ;port
		add	dx,4	;/DTR=0 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	ax
		pop	dx
loc_153:
		call	sub_17
		mov	ax,1
		call	dword ptr cs:data_76
		mov	cs:data_120,0
		mov	cs:data_122,0
		mov	cs:data_121,0
		mov	cs:data_141,0
		mov	cs:data_123,0
		mov	cs:data_144,0
		mov	cs:data_131,0
		mov	cs:data_145,4
		jmp	short loc_155
		db	90h
loc_154:
		mov	cs:data_141,0
		call	sub_21
loc_155:
		cli
		mov	ss,cs:data_37
		mov	sp,cs:data_38
		pop	ax
		sti
		retn
loc_156:
		cmp	cs:data_123,36h
		jb	loc_155
		jmp	short loc_153
loc_157:
		push	ax
		in	al,61h	; port 61h, 8255 port B, read
		and	al,0FDh
		out	61h,al	; port 61h, 8255 B - spkr, etc
				;  al = 0, disable parity
		mov	al,34h
		out	43h,al	; port 43h, 8253 wrt timr mode
		xor	ax,ax
		out	40h,al	; port 40h, 8253 timer 0 clock
		jmp	short $+2
		out	40h,al	; port 40h, 8253 timer 0 clock
		push	es
		push	cx
		push	di
		push	bx
		cld
		mov	di,cs:data_132
		push	cs
		pop	es
		mov	cx,7D0h
		mov	ax,0FFFFh
		rep	stosw
	;⠭ int0c,0d (irq3,4)
		xor	bx,bx
		mov	es,bx
		mov	bl,cs:data_41 ;irq3,4
		add	bl,8
		shl	bx,1
		shl	bx,1
		mov	word ptr es:[bx],offset m1E03
		mov	es:[bx+2],cs
		pop	bx
		pop	di
		pop	cx
		pop	es
		mov	cs:data_123,0
		cmp	cs:data_55,2
		jne	loc_158
		mov	cs:data_123,3
		push	dx
		mov	al,0Fh
		mov	dx,cs:data_43 ;port
		add	dx,4	;/DTR=1 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		mov	ax,5Fh
		push	ax
		call	sub_23
		jmp	short loc_159
		db	90h
loc_158:
		push	dx
		mov	al,0Fh
		mov	dx,cs:data_43 ;port
		add	dx,4	;/DTR=1 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		mov	ax,104h
		push	ax
		call	sub_23
loc_159:
		pop	dx
		pop	ax
		mov	word ptr cs:data_132+2,cs
		mov	cs:data_122,2
		call	sub_20
		jmp	short loc_162
		db	90h
loc_160:
		mov	cs:data_122,5
		call	sub_22
		mov	cs:data_123,0
		mov	cs:data_141,0
		jmp	loc_155
		cmp	cs:data_144,0
		jne	loc_160
		cmp	cs:data_123,4
		je	loc_161
		jmp	loc_155
loc_161:
		mov	cs:data_126,1
		mov	cs:data_122,2
		jmp	loc_155
loc_162:
		cld
		mov	cs:data_127,0
		mov	cs:data_126,0
		push	ax
		push	dx
		mov	ax,0C8h
		push	ax
		call	sub_24
		sti
		call	sub_26
		or	ax,ax
		pop	dx
		pop	ax
		jnz	loc_163
		mov	cs:data_122,3
		mov	cs:data_123,0
		jmp	loc_154
loc_163:
		mov	cs:data_142,0
		mov	cs:data_153,0
		mov	cs:data_143,offset m125A ;'noise'
loc_164:
		mov	cs:data_131,0
		mov	cs:data_122,4
		mov	cs:data_123,0
		inc	cs:data_144
		jmp	loc_154
loc_165:
		push	ax
		cld
		call	sub_27
		mov	cs:data_153,0
		call	sub_28
		or	ax,ax
		jz	loc_166
		mov	cs:data_143,offset m126E ;'no answerback'
		cmp	ax,0FFFFh
		pop	ax
		jz	loc_164
		push	ax
loc_166:
		mov	cs:data_143,0
		pop	ax
		mov	cs:data_122,4
		jmp	loc_154
loc_167:
		cmp	cs:data_60,0
		je	loc_168
		mov	cs:data_128,1
		jmp	loc_154
loc_168:
		mov	cs:data_128,0
	;!!!!!!
		call	sub_29 ;뤠  p

		cmp	cs:data_55,2
		mov	cs:data_123,32h
		jnz	loc_169
		mov	cs:data_123,0
loc_169:
		mov	cs:data_122,5
		call	sub_22
		jmp	loc_154
loc_170:
		mov	cs:data_145,12h
		cmp	cs:data_55,2
		jne	loc_171
		jmp	short loc_175
		db	90h
loc_171:
		mov	cs:data_145,4
		cmp	cs:data_115,1
		jb	loc_172
		ja	loc_174
		inc	cs:data_116
loc_172:
		cmp	cs:data_141,1Eh
		jb	loc_173
		cmp	cs:data_141,78h
		ja	loc_173
		inc	cs:data_117
		mov	cs:data_118,0
		jmp	short loc_177
		db	90h
loc_173:
		cmp	cs:data_117,3
		jb	loc_176
		inc	cs:data_118
		cmp	cs:data_118,3
		jb	loc_177
		inc	cs:data_115
		jmp	short loc_176
		db	90h
loc_174:
		cmp	cs:data_116,6
		jbe	loc_175
		cmp	cs:data_116,14h
		jae	loc_175
		call	sub_22
		jmp	short loc_178
		db	90h
loc_175:
		mov	cs:data_115,0
		mov	cs:data_116,0
loc_176:
		mov	cs:data_117,0
		mov	cs:data_118,0
loc_177:
		cmp	cs:data_55,2
		je	loc_178
		jmp	short loc_181
		db	90h
loc_178:
		push	bx
		push	es
		xor	bx,bx
		mov	es,bx
		mov	bl,cs:data_41 ;irq3,4
		add	bl,8
		shl	bx,1
		shl	bx,1
		cli		;⠭ irq3,4
		mov	word ptr es:[bx],offset m07E6
		mov	es:[bx+2],cs
		sti
		call	sub_18
		pop	es
		pop	bx
		cmp	cs:data_55,2
		je	loc_180
		cmp	cs:data_122,8
		jne	loc_179
		jmp	loc_152
loc_179:
		mov	cs:data_122,6
		jmp	loc_151
loc_180:
		push	ax
		push	dx
		mov	al,0Eh
		mov	dx,cs:data_43 ;port
		add	dx,4	;/DTR=0 /RTS=1 /OUT1,2=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	dx
		pop	ax
		mov	cs:data_122,7
		mov	cs:data_123,0
		jmp	loc_154
loc_181:
		cmp	cs:data_123,36h
		jge	loc_185
		cmp	cs:data_123,2
		jne	loc_182
	;!!!!!!
		call	sub_29 ;뤠  p
loc_182:
		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		add	dx,6
		in	al,dx	; port 3FEh, RS232-1 modem stat
		and	al,20h	;DSR
		jz	loc_183
		inc	cs:data_121
		mov	al,cs:data_145
		cmp	cs:data_121,al
		jb	loc_184
		jmp	loc_178
loc_183:
		mov	cs:data_121,0
loc_184:
		pop	dx
		pop	ax
		jmp	loc_154
loc_185:
		mov	cs:data_85,1
		mov	cs:data_120,1
		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		inc	dx
		xor	ax,ax
		out	dx,al	; port 3F9h, RS232-1 int enable
		;p pp뢠
				;  al = 0, all interrupts off
		mov	ax,352h
		push	ax
		call	sub_25
		mov	cs:data_120,0
		call	sub_32
		mov	al,8
		out	dx,al	; port 3F9h, RS232-1 int enable
		;int for STS,DSR,RI,RLSD
		pop	dx
		pop	ax
		mov	cs:data_123,0
		call	sub_22
		jmp	loc_154
sub_19		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:1312, 144F

sub_20		proc	near
		push	ax
		push	es
		xor	ax,ax
		mov	es,ax
		mov	ax,es:data_2e
		mov	cs:data_124,ax
		mov	ax,es:data_3e
		mov	cs:data_125,ax
		mov	es:data_3e,cs
		mov	word ptr es:data_2e,offset m1DC0
		in	al,21h	; port 21h, 8259-1 int IMR
		mov	cs:data_129,al
		in	al,0A1h
		mov	cs:data_130,al
		mov	al,0FFh
		out	0A1h,al	; port 0A1h, inhibit IRQ8 RTC
				;  al = 0FFh, inhibit interrupts
		mov	al,0FEh
		out	21h,al	; port 21h, 8259-1 int comands
				;  al = 0FEh, IRQ0 (timer) only
		pop	es
		pop	ax
		retn
sub_20		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:134A, 13A6

sub_21		proc	near
		push	ax
		push	es
		xor	ax,ax
		mov	es,ax
		cli
		mov	ax,cs:data_124
		mov	es:data_2e,ax
		mov	ax,cs:data_125
		mov	es:data_3e,ax
		mov	al,cs:data_129
		out	21h,al	; port 21h, 8259-1 int comands
		mov	al,cs:data_130
		out	0A1h,al	; port 0A1h, inhibit IRQ8 RTC
		pop	es
		pop	ax
		retn
sub_21		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:145B, 1555, 15CC, 16C3

sub_22		proc	near
		mov	cs:data_117,0
		mov	cs:data_118,0
		mov	cs:data_115,0
		mov	cs:data_116,0
		retn
sub_22		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:1429, 143F

sub_23		proc	near
		push	bp
		mov	bp,sp
		push	ax
		push	bx
		push	dx
		xor	dx,dx
loc_186:
		xor	al,al
		out	43h,al	; port 43h, 8253 wrt timr mode
				;  al = 0, timer 0 count mode
		jmp	short $+2
		in	al,40h	; port 40h, 8253 timer 0 clock
		mov	ah,al
		in	al,40h	; port 40h, 8253 timer 0 clock
		xchg	ah,al
		or	dx,dx
		jz	loc_187
		push	bx
		sub	bx,ax
		cmp	bx,4A9h
		pop	bx
		jc	loc_186
loc_187:
		mov	bx,ax
		inc	dx
		cmp	dx,[bp+4]
		jbe	loc_186
		pop	dx
		pop	bx
		pop	ax
		pop	bp
		retn	2
sub_23		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:14A3

sub_24		proc	near
		push	bp
		mov	bp,sp
		push	bx
		push	cx
		push	dx
		push	si
		push	ax
		xor	si,si
		mov	cl,0Fh
		mov	dx,cs:data_43	; (7EA9:0288=3F8h)
		add	dx,4
loc_188:
		xor	al,al
		out	43h,al	; port 43h, 8253 wrt timr mode
				;  al = 0, timer 0 count mode
		jmp	short $+2
		in	al,40h	; port 40h, 8253 timer 0 clock
		mov	ah,al
		in	al,40h	; port 40h, 8253 timer 0 clock
		xchg	ah,al
		or	si,si
		jz	loc_189
		push	bx
		sub	bx,ax
		cmp	bx,4A9h
		pop	bx
		jc	loc_188
loc_189:
		mov	bx,ax
		xor	cl,1
		mov	al,cl	;
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		inc	si
		cmp	si,[bp+4]
		jbe	loc_188
		mov	al,0Fh	;/DTR=1 /RTS=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	ax
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	bp
		sti
		retn	2
sub_24		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:16AC

sub_25		proc	near
		push	bp
		mov	bp,sp
		push	bx
		push	cx
		push	dx
		push	si
		push	di
		push	ax
		mov	di,500h
		mov	cs:data_119,0FF00h
		mov	ax,di
		out	42h,al	; port 42h, 8253 timer 2 spkr
		jmp	short $+2
		mov	al,ah
		out	42h,al	; port 42h, 8253 timer 2 spkr
		in	al,61h	; port 61h, 8255 port B, read
		or	al,3
		out	61h,al	; port 61h, 8255 B - spkr, etc
		xor	si,si
		mov	cl,0Fh
		mov	dx,cs:data_43 ;port
		add	dx,4
loc_190:
		xor	al,al
		out	43h,al	; port 43h, 8253 wrt timr mode
				;  al = 0, timer 0 count mode
		jmp	short $+2
		in	al,40h	; port 40h, 8253 timer 0 clock
		mov	ah,al
		in	al,40h	; port 40h, 8253 timer 0 clock
		xchg	ah,al
		or	si,si
		jz	loc_191
		push	bx
		sub	bx,ax
		cmp	bx,57Ch
		pop	bx
		jc	loc_190
loc_191:
		mov	bx,ax
		xor	cl,1
		mov	al,cl
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		push	ax
		mov	ax,si
		and	ax,7
		cmp	ax,7
		jne	loc_192
		mov	ax,di
		out	42h,al	; port 42h, 8253 timer 2 spkr
		jmp	short $+2
		mov	al,ah
		out	42h,al	; port 42h, 8253 timer 2 spkr
		add	di,cs:data_119
		cmp	di,500h
		ja	loc_194
		cmp	di,200h
		jb	loc_195
loc_192:
		pop	ax
		inc	si
		cmp	si,[bp+4]
		ja	loc_193
		jmp	short loc_190
loc_193:
		mov	al,0Fh	;/DTR=1 /RTS=1
		out	dx,al	; port 3FCh, RS232-1 modem ctrl
		pop	ax
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	bp
		sti
		retn	2
loc_194:

		mov	cs:data_119,0FF00h
		jmp	short loc_192
loc_195:
		mov	cs:data_119,100h
		jmp	short loc_192
sub_25		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:14A7

sub_26		proc	near
		push	bx
		push	cx
		push	dx
		push	di
		push	ds
		push	es
		push	cs
		pop	ds
		mov	cs:data_123,0
		mov	cs:data_131,0
		les	di,dword ptr cs:data_132
		mov	dx,cs:data_43
		add	dx,6
		xor	bx,bx
		xor	si,si
loc_196:
		in	al,dx	; port 3FEh, RS232-1 modem stat
		and	al,10h	;CTS
		cmp	al,bl
		jne	loc_200
		cmp	cs:data_123,7
		jne	loc_197
		cmp	cs:data_131,14h
		ja	loc_197
loc_197:
		cmp	cs:data_123,14h
		jb	loc_196
		cmp	cs:data_131,0C8h
		jle	loc_199
loc_198:
		xor	ax,ax
		jmp	short loc_204
		db	90h
loc_199:
		mov	ax,0FFFFh
		jmp	short loc_204
		db	90h
loc_200:
		cmp	cs:data_131,7D0h
		jae	loc_198
		mov	bl,al
		cmp	bh,5
		jae	loc_201
		inc	bh
		jmp	short loc_196
loc_201:
		cli
		xor	ax,ax
		out	43h,al	; port 43h, 8253 wrt timr mode
				;  al = 0, timer 0 count mode
		jmp	short $+2
		in	al,40h	; port 40h, 8253 timer 0 clock
		mov	ah,al
		in	al,40h	; port 40h, 8253 timer 0 clock
		xchg	ah,al
		xchg	ax,cx
		cmp	bh,5
		je	loc_203
		sub	ax,cx
		cmp	ax,1000h
		jb	loc_202
		mov	ax,0FFFh
loc_202:
		stosw
		inc	cs:data_131
loc_203:
		sti
		mov	bh,6
		jmp	short loc_196
loc_204:
		sti
		push	ax
		mov	ax,0FFFFh
		stosw
		pop	ax
		pop	es
		pop	ds
		pop	di
		pop	dx
		pop	cx
		pop	bx
		retn
sub_26		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:14F1

sub_27		proc	near
		push	bp
		push	ax
		push	bx
		push	cx
		push	dx
		push	di
		push	si
		push	ds
		push	cs
		pop	ds
		mov	si,cs:data_132
loc_205:
		mov	cs:data_134,1
		push	si
		lodsw
		mov	dx,ax
		cmp	ax,0FFFFh
		jne	loc_206
		jmp	loc_220
loc_206:
		mov	di,offset data_154
		mov	cx,0Ch
		mov	bx,offset data_156
locloop_207:
		mov	word ptr [bx],0
		mov	word ptr [bx+2],0
		mov	word ptr [di+6],0
		mov	word ptr [di+8],1
		mov	bp,[di+2]
		add	bp,[di+4]
		mov	[di],bp
		add	di,0Ah
		add	bx,4
		loop	locloop_207
loc_208:
		cmp	dx,174Dh
		jb	loc_209
		jmp	short loc_213
		db	90h
loc_209:
		push	si
		mov	di,offset data_154
		mov	bx,offset data_157
		mov	cx,0Ch
locloop_210:
		cmp	dx,[di]
		jb	loc_211
		mov	ax,[di]
		sub	ax,[di+6]
		mov	si,cs:data_134
		xor	si,[di+8]
		add	[bx+si],ax
		mov	ax,[di]
		mov	[di+6],ax
		add	ax,[di+2]
		mov	[di],ax
		neg	word ptr [di+8]
		jmp	short locloop_210
loc_211:
		mov	ax,dx
		sub	ax,[di+6]
		mov	si,cs:data_134
		xor	si,[di+8]
		add	[bx+si],ax
		mov	[di+6],dx
		add	di,0Ah
		add	bx,8
		cmp	cx,7
		jne	loc_212
		mov	bx,1E9Ch
loc_212:
		loop	locloop_210
		neg	cs:data_134
		pop	si
		lodsw
		add	dx,ax
		cmp	ax,0FFFFh
		jne	loc_208
		jmp	short loc_220
		db	90h
loc_213:
		xor	ax,ax
		mov	dx,4A90h
		mov	di,offset data_156
loc_214:
		mov	cx,4
locloop_215:
		cmp	[di],dx
		jae	loc_216
		mov	bl,al
		mov	dx,[di]
loc_216:
		inc	di
		inc	di
		loop	locloop_215
		inc	ax
		cmp	ax,6
		jne	loc_214
		xor	ax,ax
		mov	dx,4A90h
		mov	di,offset data_156
		mov	bh,bl
loc_217:
		mov	cx,4
locloop_218:
		cmp	[di],dx
		jae	loc_219
		cmp	bh,al
		je	loc_219
		mov	bl,al
		mov	dx,[di]
loc_219:
		inc	di
		inc	di
		loop	locloop_218
		inc	ax
		cmp	ax,6
		jne	loc_217
		pop	di
		mov	[di],bx
		mov	[di+2],si
		jmp	loc_205
loc_220:
		pop	si
		mov	word ptr [si],0
		mov	word ptr [si+2],0
		mov	si,cs:data_132
		xor	dx,dx
		xor	cx,cx
		xor	bp,bp
		mov	bx,offset data_137
		mov	cs:data_135,0
loc_221:
		lodsw
		mov	dl,ah
		xor	ah,ah
		mov	di,offset data_158
		shl	ax,1
		shl	dx,1
		add	di,ax
		mov	di,[di]
		add	di,dx
		mov	dx,[di]
		cmp	cx,dx
		je	loc_227
		cmp	bp,2
		jl	loc_225
loc_222:
		cmp	cs:data_135,7
		jle	loc_223
		mov	byte ptr [bx],0FEh
		inc	bx
		sub	cs:data_135,7
		jmp	short loc_222
loc_223:
		cmp	[bx-1],cl
		je	loc_224
		mov	[bx],cl
		inc	bx
loc_224:
		mov	cs:data_135,0
		jmp	short loc_226
		db	90h
loc_225:
		cmp	bx,121Ah
		je	loc_226
		inc	cs:data_135
		add	cs:data_135,bp
loc_226:
		mov	cx,dx
		xor	bp,bp
		jmp	short loc_228
		db	90h
loc_227:
		inc	bp
loc_228:
		mov	si,[si]
		or	si,si
		jz	loc_229
		jmp	short loc_221
loc_229:
		mov	byte ptr [bx],0Ah
loc_230:
		cmp	bx,1239h
		je	loc_231
		inc	bx
		mov	byte ptr [bx],0FFh
		jmp	short loc_230
loc_231:
		pop	ds
		pop	si
		pop	di
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		pop	bp
		retn
sub_27		endp

data_146	dw	0
data_147	dw	0
data_148	dw	0
data_149	dw	0
data_150	dw	0
		db	0, 0
data_151	dw	0
data_152	dw	0
data_153	dw	0

;	       SUBROUTINE
;
;         Called from:	 7EA9:14FB

sub_28		proc	near
		push	cx
		push	bx
		push	dx
		push	di
		push	si
		push	ds
		push	cs
		pop	ds
		mov	si,offset data_137
		mov	cs:data_151,0
		mov	cs:data_148,0
		mov	cs:data_152,0
loc_232:
		lodsb
		cmp	al,0Ah
		jne	loc_233
		jmp	loc_241
loc_233:
		test	al,80h
		jnz	loc_234
		jmp	short loc_238
		db	90h
loc_234:
		mov	di,si
		sub	di,0Ah
		cmp	di,offset data_137
		jb	loc_235
		test	byte ptr [di],80h
		jnz	loc_235
		mov	al,[di]
		mov	[si-1],al
		jmp	short loc_238
		db	90h
loc_235:
		mov	di,si
		add	di,8
		cmp	di,offset data_138
		jae	loc_236
		test	byte ptr [di],80h
		jnz	loc_236
		cmp	byte ptr [di],0Ah
		je	loc_236
		mov	al,[di]
		mov	[si-1],al
		jmp	short loc_238
		db	90h
loc_236:
		mov	bx,cs:data_151
		cmp	bx,3
		jae	loc_237
		shl	bx,1
		add	bx,offset data_149
		mov	[bx],si
		dec	word ptr [bx]
loc_237:
		inc	cs:data_151
		jmp	short loc_232
loc_238:
		cmp	al,0Dh
		je	loc_239
		jmp	short loc_232
loc_239:
		mov	bx,cs:data_148
		shl	bx,1
		add	bx,offset data_146
		mov	[bx],si
		dec	word ptr [bx]
		cmp	cs:data_148,2
		jne	loc_240
		mov	byte ptr [si-1],0Ah
		jmp	short loc_241
		db	90h
loc_240:
		inc	cs:data_148
		jmp	loc_232
loc_241:
		mov	cs:data_152,si
		sub	cs:data_152,offset data_137+1 ;121Bh ;????
loc_242:
		cmp	cs:data_148,2
		jne	loc_244
		mov	si,cs:data_147
		mov	cx,7
		mov	di,offset data_138
		dec	si
		std
locloop_243:
		lodsb
		mov	[di],al
		inc	di
		loop	locloop_243
		cld
		jmp	loc_255
loc_244:
		cmp	cs:data_148,0
		je	loc_249
		mov	si,cs:data_146
		mov	di,offset data_139
		mov	cx,7
		cld
		inc	si
		lodsb
		cmp	al,0Ah
		je	loc_246
locloop_245:
		lodsb
		cmp	al,0Ah
		je	loc_246
		mov	[di],al
		dec	di
		loop	locloop_245
		jmp	loc_255
loc_246:
		mov	bx,cs:data_146
		mov	si,offset data_137
		sub	bx,si
locloop_247:
		cmp	cx,bx
		jle	locloop_248
		mov	byte ptr [di],0FFh
		dec	di
		loop	locloop_247
		jmp	loc_255
locloop_248:
		mov	si,cs:data_146
		sub	si,cx
		lodsb
		mov	[di],al
		dec	di
		loop	locloop_248
		jmp	loc_255
loc_249:
		cmp	cs:data_151,0
		jne	loc_250
		mov	ax,0FFFFh
		mov	cs:data_153,1
		jmp	loc_256
loc_250:
		cmp	cs:data_151,1
		jne	loc_252
		cmp	cs:data_152,9
		jae	loc_251
		mov	ax,0FFFFh
		mov	cs:data_153,1
		jmp	short loc_256
		db	90h
loc_251:
		mov	si,cs:data_149
		mov	byte ptr [si],0Dh
		inc	cs:data_148
		mov	cs:data_146,si
		dec	cs:data_151
		jmp	loc_242
loc_252:
		cmp	cs:data_151,2
		jne	loc_254
		mov	di,cs:data_150
		sub	di,cs:data_149
		cmp	di,9
		je	loc_253
		mov	ax,0FFFFh
		mov	cs:data_153,1
		jmp	short loc_256
		db	90h
loc_253:
		mov	si,cs:data_149
		mov	byte ptr [si],0Dh
		inc	cs:data_148
		mov	cs:data_146,si
		dec	cs:data_151
		mov	si,cs:data_150
		mov	byte ptr [si],0Dh
		inc	cs:data_148
		mov	cs:data_147,si
		dec	cs:data_151
		jmp	loc_242
loc_254:
		mov	ax,0FFFFh
		mov	cs:data_153,1
		jmp	short loc_256
		db	90h
loc_255:
		xor	ax,ax
loc_256:
		mov	cs:data_142,0
		or	ax,ax
		jnz	loc_257
		mov	cs:data_142,offset data_138 ;123Ah
loc_257:
		pop	ds
		pop	si
		pop	di
		pop	dx
		pop	bx
		pop	cx
		retn
sub_28		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:1538, 1661
	; 뤠 p  p
sub_29		proc	near
		push	bp
		push	ax
		push	bx
		push	cx
		push	dx
		push	si
		push	di
		push	ds
		push	es
		call	sub_30
		push	cs
		pop	ds
		push	cs
		pop	es
		mov	ax,300h
		mov	bx,1Fh
		int	10h	; Video display   ah=functn 03h
				;  get cursor loc in dx, mode cx
		push	dx
		xor	dx,dx
		mov	ax,200h
		int	10h	; Video display   ah=functn 02h
	;砫 p		;  set cursor location in dx
		cmp	cs:data_143,0
		je	loc_259
		mov	si,cs:data_143
loc_258: ;뤠   d_143
		mov	al,[si]
		cmp	al,0
		je	loc_259
		mov	ah,9
		mov	bx,1Fh
		mov	cx,1
		int	10h	; Video display   ah=functn 09h
				;  set char al & attrib bl @curs
				;   cx=# of chars to replicate
		inc	dx
		mov	ah,2
		int	10h	; Video display   ah=functn 02h
				;  set cursor location in dx
		inc	si
		jmp	short loc_258
loc_259:
		cmp	cs:data_142,0
		je	loc_264
		mov	si,offset data_138
		mov	cx,7
		xor	bp,bp
locloop_260: ;뤠   d_138 (number?)
		mov	al,[si]
		cmp	al,0Eh
		jne	loc_261
		mov	ax,bp
loc_261:
		mov	bp,ax
		test	al,80h
		jnz	loc_263
loc_262:
		add	ax,30h
		mov	ah,9
		mov	bx,1Fh
		push	cx
		mov	cx,1
		int	10h	; Video display   ah=functn 09h
				;  set char al & attrib bl @curs
				;   cx=# of chars to replicate
		inc	dx
		mov	ah,2
		int	10h	; Video display   ah=functn 02h
				;  set cursor location in dx
		pop	cx
		inc	si
		loop	locloop_260

		mov	cx,0Bh
		mov	ax,920h
		mov	bx,1Fh
		int	10h	; Video display   ah=functn 09h
				;  set char al & attrib bl @curs
				;   cx=# of chars to replicate
		jmp	short loc_269
		db	90h
loc_263:
		mov	al,0FAh
		jmp	short loc_262
loc_264:
		cmp	cs:data_153,0
		jmp	short loc_269

		NOP

		XOR	BP,BP
		MOV	SI,offset data_137
		ADD	SI,cs:[data_152]
		MOV	CX,cs:[data_152]

locloop_265:
		mov	al,[si]
		cmp	al,0Dh
		je	loc_268
		cmp	al,0Eh
		jne	loc_266
		mov	ax,bp
loc_266:
		mov	bp,ax
		test	al,80h
		jnz	loc_268
loc_267:
		add	ax,30h
		mov	ah,9
		mov	bx,1Fh
		push	cx
		mov	cx,1
		int	10h	; Video display   ah=functn 09h
				;  set char al & attrib bl @curs
				;   cx=# of chars to replicate
		inc	dx
		mov	ah,2
		int	10h	; Video display   ah=functn 02h
				;  set cursor location in dx
		pop	cx
		dec	si
		loop	locloop_265
		jmp	short loc_269
		db	90h
loc_268:
		mov	al,0Fh
		jmp	short loc_267
loc_269:
		pop	dx
		mov	ax,200h
		int	10h	; Video display   ah=functn 02h
				;  set cursor location in dx
		call	sub_31
		pop	es
		pop	ds
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		pop	bp
		retn
sub_29		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:1CA7

sub_30		proc	near
		push	ax
		push	es
		cli
		xor	ax,ax
		mov	es,ax
		mov	ax,word ptr cs:data_63
		mov	es:data_5e,ax
		mov	ax,word ptr cs:data_63+2
		mov	es:data_6e,ax
		sti
		pop	es
		pop	ax
		retn
sub_30		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:1D78

sub_31		proc	near
		push	ax
		push	es
		cli
		xor	ax,ax
		mov	es,ax
		mov	word ptr es:data_5e,offset m11D7
		mov	es:data_6e,cs
		sti
		pop	es
		pop	ax
		retn
sub_31		endp


;	       SUBROUTINE
;
;         Called from:	 7EA9:16B5

sub_32		proc	near
		push	ax
		in	al,61h	; port 61h, 8255 port B, read
		and	al,0FCh	;xxxxxx00 -  p饭
		out	61h,al	; port 61h, 8255 B - spkr, etc
		pop	ax
		retn
sub_32		endp

m1dc0:		push	ax
		inc	cs:data_123
		mov	al,20h
		out	20h,al	; port 20h, 8259-1 int command
				;  al = 20h, end of interrupt
		pop	ax
		iret

;	       SUBROUTINE
;
;         Called from:	 7EA9:119C

sub_33		proc	near
loc_270:
		sti
		cmp	cs:data_58,0
		jne	loc_ret_271
		cmp	cs:data_126,0
		jne	loc_270
loc_ret_271:
		retn
sub_33		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:11BE

sub_34		proc	near
loc_272:
		sti
		cmp	cs:data_59,0
		jne	loc_ret_271
		cmp	cs:data_127,0
		jne	loc_272
		jmp	short loc_ret_271
sub_34		endp

;	       SUBROUTINE
;
;         Called from:	 7EA9:11E0

sub_35		proc	near
loc_273:
		sti
		cmp	cs:data_60,0
		jne	loc_ret_271
		cmp	cs:data_128,0
		jne	loc_273
		retn
sub_35		endp

	;int0c,0d (irq3,4)
m1e03:		push	ax
		push	dx
		mov	dx,cs:data_43 ;port
		add	dx,6
		in	al,dx	; port 3FEh, RS232-1 modem stat
		test	al,1	; CTS
		jz	loc_274
		inc	cs:data_141
loc_274:
		mov	al,20h
		out	20h,al	; port 20h, 8259-1 int command
				;  al = 20h, end of interrupt
		pop	dx
		pop	ax
		iret

data_154	db	0
		db	0,54h,3,0,0,0
		db	0,1,0,0,0,97h
		db	2,0,0,0,0,1
		db	0,0,0,1Eh,2,0
		db	0,0,0,1,0,0
		db	0,0CBh,1,0,0,0
		db	0,1,0,0,0,8Eh
		db	1,0,0,0,0,1
		db	0,0,0,5Fh,1,0
		db	0,0,0,1,0,0
		db	0,54h,3,56h,0FEh,0
		db	0,1,0,0,0,97h
		db	2,0B4h,0FEh,0,0,1
		db	0,0,0,1Eh,2,0F1h
		db	0FEh,0,0,1,0,0
		db	0,0CBh,1,1Ah,0FFh,0
		db	0,1,0,0,0,8Eh
		db	1,39h,0FFh,0
data_155	db	0
		db	1,0,0,0,5Fh,1
		db	50h,0FFh,0,0,1,0
data_156	dw	0

data_157	db	0
		db	45 dup (0)
data_158	db	0D2h
		db	1Eh,0DEh,1Eh,0EAh,1Eh,0F6h
		db	1Eh,2,1Fh,0Eh,1Fh,0FFh
		db	0FFh,1,0,2,0,4
		db	0,7,0,0Ch,0
		db	1
		db	0,0FFh,0FFh,3,0,5
		db	0,8,0,0Ch,0,2
		db	0,3,0,0FFh,0FFh,6
		db	0,9,0,0Dh,0,4
		db	0,5,0,6,0,0FFh
		db	0FFh,0,0,0Eh,0,7
		db	0,8,0,9,0,0
		db	0,0FFh,0FFh,0FFh,0FFh,0Bh
		db	0,0Ch,0,0Dh,0,0Eh
		db	0,0FFh,0FFh,0FFh,0FFh,0
		db	3863 dup (0)
		dw	0
		db	230 dup (0)

	;    ⠫
m2f1a:		PUSH	ES
		PUSH	DI
		PUSH	CS
		POP	DS
		MOV	AX,es:[DI+14h]
		PUSH	AX
		MOV	AX,es:[DI+12h]
		PUSH	AX
		MOV	DX,offset m310E ;⠢
		MOV	AH,09
		INT	21h
		CALL	m32CA	;pp .p
		POP	CX
		POP	CX
		CMP	AX,1
		JZ	m2F55	;error
		CALL	m3206	;pp.⠢
		CMP	AX,1
		JNZ	m2F77	;normal
		PUSH	CS
		POP	DS
		MOV	DX,offset data_169 ;not load
		MOV	AH,09
		INT	21h
		PUSH	CS
		POP	DS
		MOV	DX,offset m3096 ;inv.param.
		MOV	AH,09
		INT	21h
		JMP	short m2F67	;EXIT

m2f55:		PUSH	CS
		POP	DS
		MOV	DX,offset data_169 ;not load
		MOV	AH,09
		INT	21h
		PUSH	CS
		POP	DS
		MOV	DX,offset data_168 ;inv.arg
		MOV	AH,09
		INT	21h
m2f67:		POP	DI
		POP	ES
		MOV	WORD PTR es:[DI+0Eh],0
		MOV	word ptr es:[DI+10h],CS
		MOV	AX,8001h
		RETn

m2f77:		PUSH	CS	;normal
		POP	DS
		MOV	DX,offset data_170 ;drv.load
		MOV	AH,09
		INT	21h
		PUSH	CS
		POP	DS
		MOV	DX,offset data_162 ;cur.conf
		MOV	AH,09
		INT	21h
		POP	DI
		POP	ES
		MOV	WORD PTR es:[DI+0Eh],offset m2F1A
		MOV	es:[DI+10h],CS ;addr  
		XOR	AX,AX
		MOV	ES,AX
		MOV	AX,es:[20h]	;int08
		MOV	word ptr cs:[data_39],AX
		MOV	AX,es:[22h]	;int08
		MOV	word ptr cs:[data_39+2],AX
		MOV	word ptr es:[22h],CS
		MOV	WORD PTR es:[20h],offset m06CA
		MOV	AX,es:[4Ch]	;int13
		MOV	word ptr cs:[data_61],AX
		MOV	AX,es:[4Eh]	;int13
		MOV	word ptr cs:[data_61+2],AX
		MOV	word ptr es:[4Eh],CS
		MOV	WORD PTR es:[4Ch],offset m1193
		MOV	AX,es:[100h]	;int40
		MOV	word ptr cs:[data_65],AX
		MOV	AX,es:[102h]	;int40
		MOV	word ptr cs:[data_65+2],AX
		MOV	word ptr es:[102h],CS
		MOV	WORD PTR es:[100h],offset m11B5
		MOV	AX,es:[40h]	;int10
		MOV	word ptr cs:[data_63],AX
		MOV	AX,es:[42h]	;int10
		MOV	word ptr cs:[data_63+2],AX
		MOV	word ptr es:[42h],CS
		MOV	WORD PTR es:[40h],offset m11D7
		MOV	word ptr cs:[data_76+2],CS
		MOV	WORD PTR cs:[data_76],offset m0656
		XOR	BX,BX
		MOV	BL,cs:[data_41] ;irq3,4
		ADD	BL,08
		SHL	BX,1
		SHL	BX,1	;⠭ irq3,4
		MOV	WORD PTR es:[BX],offset m07E6
		ADD	BX,+02
		MOV	es:[BX],CS
		MOV	AX,offset m115D
		CALL	AX
		XOR	AX,AX
		RETn

data_162	db	'Current Configuration: IRQ = '
m3053		db	'0h, I/O Base = 000'
m3065		db	'0h, Device Status  =  '
m307b		db	'0', 0Dh, 0Ah, 0Dh, 0Ah, '$'

data_168	db	'Invalid arguments.',13,10,'$'

m3096		db	"Invalid parameter's value. "
		db	'Run INST.EXE.',13,10,'$'

data_169	db	'CID-14 (AON) device drv. is not '
		db	'loaded.',13,10,'$'

data_170	db	'CID-14 (AON) driver loaded.     '
		db	13,10,'$'

m310e		db	13,10,0C9h
		db	26 dup (0CDh)
		db	0BBh,13,10,0BAh
		db	'CID-14 (AON) DEVICE DRIVER'
		db	0BAh,13,10,0BAh
		db	'   ATCOMM, 1994, v. 1.0   '
		db	0BAh,13,10,0C8h
		db	26 dup (0CDh)
		db	0BCh,13,10,'$'

;	       SUBROUTINE
;
;         Called from:	 7EA9:3362

sub_36		proc	near
		push	bp
		mov	bp,sp
		sub	sp,2
		push	si
		push	di
		xor	si,si
		mov	[bp-2],si
loc_279:
		les	bx,dword ptr [bp+4]
		mov	al,es:[bx+si]
		mov	ah,0
		push	ax
		call	sub_38
		pop	cx
		mov	di,ax
		cmp	di,46h
		jg	loc_280
		cmp	di,41h
		jl	loc_280
		sub	di,37h
		jmp	short loc_281
loc_280:
		cmp	di,39h
		jg	loc_282
		cmp	di,30h
		jl	loc_282
		sub	di,30h
loc_281:
		mov	ax,[bp-2]
		mov	cl,4
		shl	ax,cl
		mov	[bp-2],ax
		or	[bp-2],di
		inc	si
		jmp	short loc_279
loc_282:
		mov	ax,[bp+8]
		cmp	ax,1
		je	loc_283
		cmp	ax,2
		je	loc_284
		cmp	ax,3
		je	loc_285
		jmp	short loc_286
loc_283:  ;/b
		mov	ax,[bp-2]
		mov	cs:data_43,ax ;port
		jmp	short loc_286
loc_284:  ;/i
		mov	al,[bp-2]
		mov	cs:data_41,al ;irq3,4
		jmp	short loc_286
loc_285:  ;/l
		mov	al,[bp-2]
		mov	cs:data_42,al ;level
loc_286:
		mov	ax,si
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		retn
sub_36		endp

	;pp ⠢
m3206:		PUSH	SI
		PUSH	DI
		MOV	SI,cs:[data_43];Addr COM
		TEST	SI,0F000h
		JZ	loc_287
		JMP	loc_296

loc_287:
		mov	di,si
		and	di,0Fh
		cmp	di,0Ah
		jge	loc_288
		add	di,30h
		jmp	short loc_289
loc_288:
		add	di,37h
loc_289:
		mov	ax,di
		mov	byte ptr cs:m3065,al
		mov	di,si
		mov	cl,4
		sar	di,cl
		and	di,0Fh
		cmp	di,0Ah
		jge	loc_290
		add	di,30h
		jmp	short loc_291
loc_290:
		add	di,37h
loc_291:
		mov	ax,di
		mov	byte ptr cs:m3065-1,al
		mov	di,si
		mov	cl,8
		sar	di,cl
		and	di,0Fh
		cmp	di,0Ah
		jge	loc_292
		add	di,30h
		jmp	short loc_293
loc_292:
		add	di,37h
loc_293:
		mov	ax,di
		mov	byte ptr cs:m3065-2,al
		mov	al,cs:data_41 ;irq3,4
		mov	ah,0
		mov	si,ax
		test	si,0FFF0h
		jnz	loc_296
		cmp	si,0Ah
		jge	loc_294
		add	si,30h
		jmp	short loc_295
loc_294:
		add	si,37h
loc_295:
		mov	ax,si
		mov	byte ptr cs:m3053,al
		mov	al,cs:data_42
		mov	ah,0
		mov	si,ax
		or	si,si
		jle	loc_296
		cmp	si,5
		jl	loc_297
loc_296:
		mov	ax,1
		jmp	short loc_298
loc_297:
		add	si,30h
		mov	ax,si
		mov	byte ptr cs:m307b,al
		xor	ax,ax
loc_298:
		pop	di
		pop	si
		retn

;	       SUBROUTINE
;
;         Called from:	 7EA9:319F

sub_38		proc	near
		push	bp
		mov	bp,sp
		push	si
		mov	si,[bp+4]
		cmp	si,61h
		jl	loc_299
		cmp	si,7Ah
		jg	loc_299
		mov	ax,si
		add	ax,0FFE0h
		jmp	short loc_300
loc_299:
		mov	ax,si
		jmp	short loc_300
loc_300:
		pop	si
		pop	bp
		retn
sub_38		endp

	; pp .p (pp /b /i /l)
m32ca:		PUSH	BP
		MOV	BP,SP
		SUB	SP,+02
		PUSH	SI
		XOR	DX,DX
		MOV	SI,DX
		JMP	short loc_304
loc_301:
		or	dx,dx
		jz	loc_302
		les	bx,dword ptr [bp+4]
		add	bx,si
		cmp	byte ptr es:[bx],20h
		jne	loc_303
		jmp	loc_315
loc_302:
		les	bx,dword ptr [bp+4]
		add	bx,si
		cmp	byte ptr es:[bx],20h
		je	loc_303
		mov	dx,1
loc_303:
		inc	si
loc_304:
		les	bx,dword ptr [bp+4]
		add	bx,si
		cmp	byte ptr es:[bx],20h
		jge	loc_301
		jmp	short loc_315
loc_305:		
		les	bx,dword ptr [bp+4]
		add	bx,si
		mov	al,es:[bx]
		cbw
		cmp	ax,20h
		je	loc_306
		cmp	ax,2Dh		;'-'
		je	loc_307
		cmp	ax,2Fh		;'/'
		je	loc_307
		jmp	short loc_314
loc_306:
		inc	si
		jmp	short loc_315
loc_307:
		inc	si
		les	bx,dword ptr [bp+4]
		add	bx,si
		mov	al,es:[bx]
		cbw
		mov	[bp-2],ax
		mov	cx,6
		mov	bx,offset data_173
locloop_308:
		mov	ax,cs:[bx]
		cmp	ax,[bp-2]
		je	loc_309
		add	bx,2
		loop	locloop_308

		jmp	short loc_314
loc_309:
		jmp	word ptr cs:[bx+0Ch] ;=cs:[bx+offset datt]

; Indexed Entry Point 

loc_310:    ; param /b or /B
m3348:		inc	si
		mov	ax,1
		jmp	short loc_313

; Indexed Entry Point 

loc_311:    ; param /i or /I
		inc	si
		mov	ax,2
		jmp	short loc_313

; Indexed Entry Point 

loc_312:    ; param /l or /L
		inc	si
		mov	ax,3
loc_313:
		push	ax
		mov	ax,[bp+4]
		add	ax,si
		push	word ptr [bp+6]
		push	ax
		call	sub_36
		add	sp,6
		add	si,ax
		jmp	short loc_315
loc_314:
		mov	ax,1
		jmp	short loc_316
		jmp	short loc_314

loc_315:
		les	bx,dword ptr [bp+4]
		add	bx,si
		cmp	byte ptr es:[bx],20h
		jge	loc_305
		xor	ax,ax
loc_316:
		pop	si
		mov	sp,bp
		pop	bp
		retn

data_173	dw	0042h ;B I L b i l
		dw	0049h,004Ch,0062h
		dw	0069h,006Ch
datt		dw	offset loc_310	; /B
data_174	dw	offset loc_311	; /I (int)
data_175	dw	offset loc_312	; /L (level)
data_176	dw	offset loc_310	; /b
data_177	dw	offset loc_311	; /i
data_178	dw	offset loc_312	; /l
		db	0

seg_a		ends
		end

 CROSS REFERENCE - KEY ENTRY POINTS 

  Interrupt Usage Synopsis 

        Interrupt 10h :	Video display   ah=functn xxh
        Interrupt 10h :	 ah=02h  set cursor location in dx
        Interrupt 10h :	 ah=03h  get cursor loc in dx, mode cx
        Interrupt 10h :	 ah=09h  set char al & attrib bl @curs

  I/O	Port Usage Synopsis  

        Port 20h   : 8259-1 int command
        Port 21h   : 8259-1 int IMR
        Port 21h   : 8259-1 int comands
        Port 40h   : 8253 timer 0 clock
        Port 42h   : 8253 timer 2 spkr
        Port 43h   : 8253 wrt timr mode
        Port 61h   : 8255 port B, read
        Port 61h   : 8255 B - spkr, etc
        Port 0A1h  : inhibit IRQ8 RTC
        Port 3F9h  : RS232-1 int enable
        Port 3FCh  : RS232-1 modem ctrl
        Port 3FEh  : RS232-1 modem stat
            1 Ocurrences of Non-Standard I/O ports used.

